<?php
/**
 * append BASEURI to all urls, links, etc (except for external links)
 *
 * @author oleksiy
 */
class BaseUrlAppender extends COutputProcessor {

    public function processOutput($content)
    {
        $baseurl = Yii::app()->request->baseUrl;

        $patterns = array(
            '/<(a|link)(.*?)href=[\"\'](?!http|mailto|javascript|ftp:)(?!'.preg_quote($baseurl, '/').')(.*?)[\"\'](.*?)>/',
            '/<(img|script|input)(.*?)src=[\"\'](?!http|ftp|file:)(?!'.preg_quote($baseurl, '/').')(.*?)[\"\'](.*?)>/',
            '/<form(.*?)action=[\"\'](?!http|ftp:)(?!'.preg_quote($baseurl, '/').')(.*?)[\"\'](.*?)>/',
            '/background=[\"\'](?!http|ftp:)(?!'.preg_quote($baseurl, '/').')(.*?)[\"\']/',
            '/background[\s]{0,}:[\s]{0,}url\((?!http|ftp:)(?!'.preg_quote($baseurl, '/').')(.*?)\)/');;

        $replacements = array(
            '<$1$2href="'.$baseurl.'$3"$4>',
            '<$1$2src="'.$baseurl.'$3"$4>',
            '<form$1action="'.$baseurl.'$2"$3>',
            'background="'.$baseurl.'$1"',
            'background:url('.$baseurl.'$1)');

        $output = preg_replace($patterns, $replacements, $content);
        
        echo $output;
    }
}
?>
